<?php

namespace libs\db;

class Db
{
    protected static $instances = [];

    public static function instance($name = null)
    {
        if(empty($name)){
            $name = config('database.default');
        }
        if (!isset(static::$instances[$name])) {
            $config = config('database.connections.' . $name);
            static::$instances[$name] = new \libs\db\DbConnection($config);
        }

        return static::$instances[$name];
    }

    /**
     * @param $name
     * @param $arguments
     * @return mixed
     */
    public static function __callStatic($name, $arguments)
    {
        return static::instance()->{$name}(... $arguments);
    }
}
