<?php

namespace libs\listener;

use libs\core\Container;

class Event
{
    protected static $eventMap = [];

    /**
     * 注册事件
     */
    public static function start()
    {
        $listener = config('event.events') ?? [];
        if (empty($listener)) {
            return false;
        }

        foreach ($listener as $key => $item) {
            // 判断key值是否符合规则
            if (strpos($key, '.') === false) {
                throw new \Exception('书写规则为方法类.方法');
            }
            $keys = explode('.', $key);
            if (count($keys) !== 2) {
                throw new \Exception('书写规则为方法类.方法');
            }
            if (isset(self::$eventMap[$keys[0]])) {
                continue;
            } else {
                self::$eventMap[$keys[0]] = Container::get($item);
            }
        }
    }

    public static function emit($event_name, $data)
    {
        // 判断key值是否符合规则
        if (strpos($event_name, '.') === false) {
            throw new \Exception('书写规则为方法类.方法');
        }
        $keys = explode('.', $event_name);
        if (count($keys) !== 2) {
            throw new \Exception('书写规则为方法类.方法');
        }

        if (isset(self::$eventMap[$keys[0]])) {
            return call_user_func([self::$eventMap[$keys[0]], $keys[1]], $data);
        } else {
            self::start();
            return call_user_func([self::$eventMap[$keys[0]], $keys[1]], $data);
        }
    }
}
